#ifndef COMP_H
#define COMP_H

#include <stdio.h>

/* Globals */
extern char input_file_name[];
extern char dump_file_name[];
extern FILE *dump_file;

extern int compiler_flags;
/* Bits in compiler flags */
#define DUMP_NAMETABLES 1
#define DUMP_TREES      2
#define DUMP_RTL        4

extern type     base_type;
extern type     base_parameter_type;
extern type_ptr current_type;
extern int      frame_size;
extern int      function_end_label;
extern int      extern_def;
extern int      error_level;

extern name_ptr current_function; /* Points to global name table */

void parse_command_line(int argc, char *argv[]);
void print_help();
void error_message0(const char *txt);
void error_message1(const char *txt, const char *arg);

void init_compiler();
void finalize_compiler();
void set_type(type_ptr typ, int lex_value);
void assign_type(name_ptr n, type_ptr typ);
name_ptr process_function_name(const char *n);
name_ptr process_function_call(const char *n);
name_ptr process_variable(const char *name);
void copy_params_to_local_table(name_ptr f);
void process_local_table();
void gen_function_beg();
void gen_function_end();

extern int continue_label, break_label;

#endif
