/*
 * File "flagbits.h"
 * Flag bits used in various structures
 */
#ifndef FLAG_BITS_H
#define FLAG_BITS_H

/* Flags in modifiers field of struct tree_tag */
#define MOD_POSTFIX     1       /* Postfix operation ++, -- */
#define MOD_BYTE        2       /* byte (character) operation */
#define MOD_BOOL        4       /* boolean expression */
#define MOD_LVAL        8       /* l-value */

/* Bits in the modifiers field of struct name_entry_tag */
#define MOD_LOCAL              16   /* This is local variable */
#define MOD_GLOBAL             32   /* This is global (non-static) variable */
#define MOD_EXTERN             64   /* extern (definition in another file) */
#define MOD_FUNCT_BODY_DEFINED 128  /* Function definition is given */

/* Bits in rtx.modifiers -- the same as used by tree_tag */
#define RTX_MODPOSTFIX  MOD_POSTFIX     /* Postfix operation ++, -- */
#define RTX_MODBYTE     MOD_BYTE        /* Byte instruction */
#define RTX_MODGLOBAL   MOD_GLOBAL      /* Byte instruction */

#endif  /* FLAG_BITS_H */
