/* 
 * Work with strings
 */
#ifndef STRPOOL_H
#define STRPOOL_H

#include "list.h"

#define STRING_PREFIX ".LC"
#define STRING_PREFIX_LENGTH 3
#define MAX_STR_NAME_LENGTH (STRING_PREFIX_LENGTH + 7)

typedef struct string_tag {
    block_header link;
    char *str;
    int str_id;
    char str_name[MAX_STR_NAME_LENGTH];
} string_entry, *string_ptr;

extern block_header string_list;
void init_string_list();
string_ptr lookupStringEntry(const char *str);
const char *lookupString(const char *str);
string_ptr lookupStringIdEntry(int id);
const char *lookupStringId(int id);
string_ptr addString(const char *str);
string_ptr allocate_string_entry();
void release_string_entry(string_ptr s);
void release_string_list();

const char *getStringName(int str_id);
const char *getStringNamePrefix();

#endif /* STRPOOL_H */
